/******************************************************************************
 Common foxfm functions
 *****************************************************************************/

function foxfm_isOFMDomain(href)
{
	if (href.match("onlinefussballmanager"))
	{
		return true;
	} else {
		return false;
	}
}

function foxfm_isOFMDomainHeader(href)
{
	if (href.match("onlinefussballmanager.de/head.php"))
	{
		return true;
	} else {
		return false;
	}
}            

function foxfm_configure() 
{
    window.openDialog("chrome://foxfm/content/foxfmOptions.xul", "", "centerscreen, chrome, modal, resizable=no");
} 

function foxfm_getMaxOFMStrengthLevel()
{
	try
	{
		return prefBranchOFMStrengthLevel.get("maxlevel");
	}
	catch(e)
	{
		errorMessage(e);
	}		
}

function foxfm_getOFMStrengthLevel()
{
	try
	{
		var maxOFMLevel=foxfm_getMaxOFMStrengthLevel();
		var aStrengthLevel = new Array(maxOFMLevel);
		var prefLvlStr="";
		for(i=0; i<maxOFMLevel; i++)
		{
			aStrengthLevel[i] = prefBranchOFMStrengthLevel.get(i+1);
		}
		// alertArray(aStrengthLevel);
		return aStrengthLevel;
	}
	catch(e)
	{
		errorMessage(e);
	}		
}

function foxfm_getAddonInfoLevel()
{
	try
	{
		return prefBranchAddOn.get("infoLvl");
	}
	catch(e)
	{
		errorMessage(e);
	}		
}

function foxfm_addJavaScript(doc, js) 
{    
	var head = doc.getElementsByTagName("head")[0]; 
	var script = doc.createElement("script");
	script.type = "text/javascript";
	script.src = js;
	head.appendChild(script);
	return script;
}

function foxfmdebug(exception)
{
	window.openDialog(
        "chrome://foxfm/content/resources/html/showErrorBacktrace.htm",
        "errorbacktrace",
        "centerscreen=yes,chrome=yes,modal=yes,resizable=yes",
        exception,
        "display error"
      ); 
}

function addonerrorMessage(err)
{
	var vDebug = "";
    for (var prop in err)
    { 
       vDebug += "property: "+ prop+ " value: ["+ err[prop]+ "]\n";
    }
    vDebug += "toString(): " + " value: [" + err.toString() + "]";
    alert(vDebug);
}

function infoMessage(infoLvl, aMessage) 
{
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	gMinInfoLvl = foxfm_getAddonInfoLevel();
	// consoleService.logStringMessage("foxfm: " + infoLvl + ":" + gMinInfoLvl + ":" + infoLvl & getNumberFromString(gMinInfoLvl));
	if(infoLvl & getNumberFromString(gMinInfoLvl))
	{
		consoleService.logStringMessage("foxfm: " + aMessage);
	} else if(infoLvl==0)
	{
		consoleService.logStringMessage("foxfm: " + aMessage);
	}
}

function errorMessage(error)
{
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	// consoleService.logStringMessage("foxfm: " + infoLvl + ":" + gMinInfoLvl + ":" + infoLvl & getNumberFromString(gMinInfoLvl));
	Components.utils.reportError(error); // report the error and continue execution
}

/******************************************************************************
* This function searches each cell of the given table for the given string.
*/
function scanTableByRegExp(table, regExp)
{
	// alert("foxfm: scanTableByRegExp()");
	var tableCell	= new Array();
	var rows		= table.rows;
	var k			= 0;
	// go through the rows
	for(var i=0; i<rows.length; i++)
	{
		cells = rows[i].cells;
		// go through the cells
		for(var j=0; j<cells.length; j++)
		{
			// alert(cells[j].innerHTML);
			if(cells[j].innerHTML.match(regExp))
			{
				// alert(cells[j].innerHTML);
				tableCell[k]			= new Object();
				tableCell[k]["row"]		= i;
				tableCell[k]["cell"]	= j;
				k++;	
			}
		}
	}
	return tableCell;
}

function scanNodeByRegExp(nodes, skipTag, regExp)
{	
	// alert("Number of child node: " + nodes.length + "; innerHTML: " + nodes.innerHTML)
	// iterate through the nodes
	for(var i=0; i<nodes.length; i++)
	{
		var childNode = nodes[i];
		// get the TAG-name of the i-th child of the current node
		var childTag = childNode.tagName;
		// alert("Scanning of child tag '" + childTag + "'");
		
		// check if the current TAG is even defined
		if(childTag)
		{			
			var childHTML = childNode.innerHTML;
			var childType = childNode.nodeType;
			
			// nodeType:
			// 1  	ELEMENT_NODE
			// 2 	ATTRIBUTE_NODE
			// 3 	TEXT_NODE
			// 4 	CDATA_SECTION_NODE
			// 5 	ENTITY_REFERENCE_NODE
			// 6 	ENTITY_NODE
			// 7 	PROCESSING_INSTRUCTION_NODE
			// 8 	COMMENT_NODE
			// 9 	DOCUMENT_NODE
			// 10 	DOCUMENT_TYPE_NODE
			// 11 	DOCUMENT_FRAGMENT_NODE
			// 12	NOTATION_NODE
			if((childType === 1) && (childTag != skipTag) && !childHTML.toLowerCase().match(skipTag.toLowerCase()) && childHTML.match(regExp))
			{
				// alert("found child node: " + childHTML);
				// check if current child node has also child nodes by itself
				return true;
			} else {
				if(childHTML.match(regExp) && (childTag != skipTag))
				{
					// alert("Calling 'scanNodeByRegExp()' again with child content: '" + childHTML + "'");
					return scanNodeByRegExp(childNode.childNodes, skipTag, regExp);
				} else {
					return false;
				}
			}
		} else {
			// check next node
			continue;
		}
	}
}

function searchTable (table, lookFor1st, lookFor2nd)
{	
	// alert("foxfm: searchTable()");
	var tableCell = new Array();
	//alert(lookFor1st + " " + lookFor2nd);
	var rows = table.rows;
	// go through the rows
	for(var i=0; i<rows.length; i++)
	{
		cells = rows[i].cells;
		// go through the cells
		for(var j=0; j<cells.length; j++)
		{
			//alert(cells[j].innerHTML);
			cell = cells[j];
			if(cell.innerHTML.match(lookFor1st))
			{
				// alert(cell.innerHTML);	
				nextIndex = j+1;
				if(nextIndex<cells.length) 
				{
					if(cells[nextIndex].innerHTML.match(lookFor2nd)) 
					{
						// tableCell[k]= new Object();
						//alert(cell.innerHTML);
						//alert("HIT: '" + lookFor1st + "' and '" + lookFor2nd + "' in row " + i);
						// return the row where the string was found
						tableCell[0] = i;
						tableCell[1] = j;
						return tableCell;
					}
				}	
			}
		}
	}
	return tableCell;
}

function findTable(arrayTable, strFirst, strSecond)
{
	for(var i=0; i<arrayTable.length; i++)
	{
		// get table of team --> look for "Pos" and "Spielername"
		var tableCell = searchTable(arrayTable[i], strFirst, strSecond);
		var rowIndex = tableCell[0];
		var colIndex = tableCell[1];
		// found table?
		if(rowIndex>=0)
		{
			// return index of found table
			return i;
		}
	}
	return -1;
}

/******************************************************************************
* This function searches the given tables for the given string.
*/
function findTableByRegExp(tables, regExp)
{
	try {	
		var results = new Array();
		var k=0;
	
		/* go through the tables */
		for(var i=0; i<tables.length; i++)
		{
			// check if the current table contains the search string at all
			if(tables[i].innerHTML.match(regExp))
			{
				// cell = scanTableByRegExp(tables[i], regExp);
				// get the cells of the current table containing the search string 
				resultCells = scanTableByRegExp(tables[i], regExp);
				
				// check if the result cells do not contain another table which also might contain the search string
				// --> such table is also part of array "tables" given to  
				//     THIS function and will be searched later on
				// ==> this table could be skipped here
				for(var j=0; j<resultCells.length; j++)
				{
					// alert("found table by '" + regExp + "'");
					/* take the j-th search result of the current table */
					var cell = tables[i].rows[resultCells[j]["row"]].cells[resultCells[j]["cell"]];
					/* check if the j-th result contains another table */
					if(!cell.innerHTML.toUpperCase().match("TABLE"))
					{
						// alert("found: '" + cell.innerHTML + "'");
						// alert("found table by '" + regExp + "' with content: " + tables[i].rows[resultCells[j]["row"]].cells[resultCells[j]["cell"]].innerHTML);
						results[k] = new Object();
						// alert("found string in table '" + i + "' in row '" + cell[0] + "' and cell '" + cell[1] + "': " + tables[i].rows[cell[0]].cells[cell[1]].innerHTML);
						results[k]["table"]	= i;
						results[k]["row"]	= resultCells[j]["row"];
						results[k]["cell"]	= resultCells[j]["cell"];						
						k++;						
					} else {
						// alert("need to scan nodes of cell '" + cell.innerHTML + "'");

						// there is at least one table within the current cell which also COULD contain the search string
						// -> it is necessary to know if the sub-table includes
						//    the search string OR the search string is besides the sub-table
						// => check all the child nodes contained by the current cell but skip the "TABLE" nodes
						if(cell.hasChildNodes)
						{							
							if(scanNodeByRegExp(cell.childNodes, "TABLE", regExp))
							{
								// alert("cell.innerHTML:\n" + cell.innerHTML + "\n\nfound: " + ret);
								results[k] = new Object();
								results[k]["table"]	= i;
								results[k]["row"]	= resultCells[j]["row"];
								results[k]["cell"]	= resultCells[j]["cell"];						
								k++;						
							}
						}
					}
				}
			}
		}
		return results;
	} catch(e) {
		errorMessage(e);
	}
}

// Try to find the row of the GIVEN table which contains the GIVEN
// two strings in adjacent cells and RETURN the row.
function findRow(table, strFirst, strSecond)
{
	// alert("foxfm: searchTable()");
	//alert(strFirst + " " + strSecond);
	var rows = table.rows;
	// iterate through the rows
	for(var j=0; j<rows.length; j++)
	{
		// get cells of current row
		cells = rows[j].cells;
		// iterate through the cells
		for(var k=0; k<cells.length; k++)
		{
			//alert(cells[k].innerHTML);
			cell = cells[k];
			// check if the content is first search string 'strFirst'
			if(cell.innerHTML.match(strFirst))
			{
				//alert(cell.innerHTML);	
				nextIndex = k+1;
				// check if next cell in row contains second search string 'strSecond'
				// --> found row
				if(nextIndex<cells.length) 
				{
					if(cells[nextIndex].innerHTML.match(strSecond)) 
					{
						//alert(cell.innerHTML);
						//alert("HIT: '" + lookFor1st + "' and '" + strSecond + "' in row " + j);
						// return the row where the string was found
						return j;
					}
				}	
			}
		}
	}
	// nothing was found
	return -1;
}

// Try to find the column of the GIVEN table-row which contains the GIVEN
// string and RETURN the column.
function findColumn(row, str)
{
	// alert("foxfm: searchTable()");
	// alert(row.length);
	// iterate through the rows
	for(var i=0; i<row.length; i++)
	{
		// alert(row[i].innerHTML);	
		// check if the cell in the given row contains the search string 'str'
		// --> found column
		if(row[i].innerHTML.match(str))
		{
			// alert("HIT: '" + str + "' in column " + i);
			// return the column where the string was found
			return i;
		}
	}
	// nothing was found
	return -1;
}

function addCell(tbl, row, col, id, content, styleClass, styleAlign, styleBgColor, attrWidth)
{
	try 
	{
		var newCell = tbl.rows[row].insertCell(col);
		newCell.innerHTML = content;
		if(styleClass != "") 
		{
			newCell.className = styleClass;
		}
		newCell.align = styleAlign;
		newCell.style.backgroundColor = styleBgColor;
		newCell.id = id;
		if(attrWidth)
		{
			newCell.setAttribute("width", attrWidth);
		}
	} catch(e) {
		errorMessage(e);
	}
}

function addRow(tbl, row) //col, content, styleClass, styleAlign, styleBgColor, attrWidth)
{
	try 
	{
		tbl.insertRow(row);
	} catch(e) {
		errorMessage(e);
	}
}

function tableChangeAttributes(tbl, width)
{
	tbl.width =width;
}

function get1stOccurenceOfParentNode(node, parentTagName)
{
	var parentNode = null;
	try
	{
		infoMessage(5, "get1stOccurenceOfParentNode(): started");
		if(node && node.parentNode)
		{
			infoMessage(5, "get1stOccurenceOfParentNode(): parentNode.innerHTML: " + node.parentNode.innerHTML);

			var parent = node.parentNode;
			do
			{
				infoMessage(5, "get1stOccurenceOfParentNode(): parent.tagName: " + parent.tagName);

				if(parent.tagName.toUpperCase() == parentTagName.toUpperCase())
				{
					parentNode = parent;
				}
				if(parent.parentNode)
				{
					parent = parent.parentNode;
				} else {
					break;
				}
			}
			while(!parentNode);
		}
	} catch(e) {
		errorMessage(e);
	}
	return parentNode;
}

function getNumberFromCell(cell)
{
	try
	{
		// alert("getNumberFromCell(): cell.innerHTML: " + cell.innerHTML);
		if(cell && cell.innerHTML)
		{
			num = getNumberFromString(cell.innerHTML);
		}
		else
		{
			// alert("no number from cell");
			return NaN;
		}		

		if(isNaN(num))
		{
			// alert("try to strip number from cell");
			try 
			{
				// alert("try to get number from HTML: " + cell.getElementsByTagName("b")[0].innerHTML);
				num = getNumberFromString(cell.getElementsByTagName("b")[0].innerHTML);				
			} catch(e) {
				try
				{
					// alert("try to get number from HTML: " + cell.getElementsByTagName("strong")[0].innerHTML);
					num = getNumberFromString(cell.getElementsByTagName("strong")[0].innerHTML);					
				} catch(e) {					
					try
					{
						// alert("try to get number from HTML: " + cell.getElementsByTagName("font")[0].innerHTML);
						num = getNumberFromString(cell.getElementsByTagName("font")[0].innerHTML);
					} catch(e) {
						try
						{
							// alert("try to get number from HTML: " + cell.getElementsByTagName("div")[0].innerHTML);
							num = getNumberFromString(cell.getElementsByTagName("div")[0].innerHTML);
						} catch(e) {
							try
							{
								// alert("try to get number from HTML: " + cell.getElementsByTagName("a")[0].innerHTML);
								num = getNumberFromString(cell.getElementsByTagName("a")[0].innerHTML);
							} catch(e) {
								errorMessage("Could not get the value from the HTML string: " + cell.innerHTML);
							}
						}
					}
				}
			}
		} 
		// alert("getNumberFromHtmlString(): return(" + num +")");
		return num;
	} catch(e) {
		errorMessage(e);
	}
}

function getNumberFromNode(node)
{
	try
	{
		// alert("getNumberFromNode(" + node.innerHTML + ")");
		if(node.tagName)
		{
			for(i=0; i<node.childNodes.length; i++)
			{
				if(node.childNodes[i].nodeType == 1)
				{
					return getNumberFromNode(node.childNodes[i]);
				}
			}
		}
		num = getNumberFromString(node.innerHTML);

		return num;
	} catch(e) {
		errorMessage(e);
	}
}

function getNumberFromString (str)
{
	try
	{
		var num = parseFloat(str.replace(/\./g,""));

		return num;
	} catch(e) {
		errorMessage(e);
	}
}

function getAWP(ep, tp)
{
	return new Number(Math.round(((2*ep*tp)/(ep + tp))));
}

function getAWPs(eps, tps)
{
	var awps = new Array(eps.length);
	for(var i=0; i<eps.length; i++)
	{
		awps[i] = getAWP(eps[i], tps[i]);
	}
	return awps;
}

function getStrengthLevel(awps)
{
	// alertArray(gStrengthPoints);
	// alert(awps);
	for(var i=0; i<gStrengthPoints.length; i++)
	{
		// alert(awps + " < " + getNumberFromString(gStrengthPoints[i]));
		if(awps<getNumberFromString(gStrengthPoints[i]))
		{
			// alert("getStrengthLevel(): return( " + i + " );");
			return i;
		}
	}
	return -1;
}

function getAWPsOfLevel(level)
{
	if(level>0)
	{
		return getNumberFromString(gStrengthPoints[level-1]);
	}
	return -1;
}

function addColCurrentStrength()
{
}

function addColCurrentAWPs(tbl, rowIndex, colIndex, awps)
{
	//alert(rowIndex);
	//alert(tbl.rows[rowIndex].cells[0].innerHtml);
	addCell(tbl, rowIndex, colIndex, null, "<a class=\"info\">AWPs<span>AWPs des Spielers</span></a>", "top", "center", "", "");
	for(var i=rowIndex+1; i<tbl.rows.length; i++) 
	{
		//alert(tbl.rows.length);
		addCell(tbl, i, colIndex, null, awps[i].toString(10), "", "center", "", "");
	}	
}

function addCurrLvlAwpsDiffNextLvl(playerTable, headerRow, ignoreRow, lvlCol, epCol, tpCol, awpCol, newColCurrLvl, newColAwpDiff, newColNextLvl)
{
	// alert("foxfm::addCurrLvlAwpsDiffNextLvl: newColNextLvl - " + newColNextLvl);
	if(newColCurrLvl)
	{
		addCell(playerTable, headerRow, newColCurrLvl, "idTblHdrTeam_CurrStrength", "<p align=center><a class=\"info\">  Aktuelle  <br>  St&auml;rke  <span>St&auml;ke des Spielers</span></a></p>", "top", "center", "", "50");
	}
	if(newColAwpDiff)
	{
		addCell(playerTable, headerRow, newColAwpDiff, "idTblHdrTeam_AWPDiff", "<p align=center><a class=\"info\">  AWPs  <br>  Diff  <span>Differenz zur n&auml;chsten St&auml;rkestufe</span></a></p>", "top", "center", "", "50");				
	}
	if(newColNextLvl)
	{
		addCell(playerTable, headerRow, newColNextLvl, "idTblHdrTeam_NextStrength", "<p align=center><a class=\"info\">N&auml;chste<br>St&auml;rke<span>Die n&auml;chsten St&auml;rkestufe</span></a></p>", "top", "center", "", "70");
	}
	var awp=NaN, tp=NaN, ep=NaN;

	for(var j=headerRow+1; j<playerTable.rows.length; j++)
	// for(var j=headerRow+1; j<headerRow+2; j++) // for debugging: only run throught the first row
	{		
		// alert(playerTable.rows[j].cells[awpCol].innerHTML);
		try
		{		
			if(j != ignoreRow)
			{
				// get the awp of the player - either from the given column or calculate it from TPs and EPs
				if(awpCol)
				{
					awp = getNumberFromCell(playerTable.rows[j].cells[awpCol]);
				} else {
					ep = getNumberFromCell(playerTable.rows[j].cells[epCol]);
					tp = getNumberFromCell(playerTable.rows[j].cells[tpCol]);
					awp = getAWP(ep, tp);
				}
				
				if(!isNaN(awp))
				{		
					var newCurrLvl = getStrengthLevel(awp);
					var currLvl = getNumberFromCell(playerTable.rows[j].cells[lvlCol]);
					var diffLvl = newCurrLvl - currLvl;
					// alert("addCurrLvlAwpsDiffNextLvl(): TP: " + tp + "; EP: " + ep + "; AWP: " + awp + "; CurrLvl: " + currLvl + "; new CurrentLvl: " + newCurrLvl);
					addCell(playerTable, j, newColCurrLvl, null, newCurrLvl + "(" + diffLvl + ")", "", "right", "", "");
					addCell(playerTable, j, newColAwpDiff, null, awp - getAWPsOfLevel(newCurrLvl+1), "", "right", "", "");
					if(newColNextLvl)
					{
						addCell(playerTable, j, newColNextLvl, null, (newCurrLvl+1) + "(" + getAWPsOfLevel(newCurrLvl+1) + ")", "", "right", "", "");
					}				
				} else {
					// This case was added for the last line in the table "Team". Otherwise no new columns would be added there!
					addCell(playerTable, j, newColCurrLvl, null, "", "", "right", "#49a084", "");
					addCell(playerTable, j, newColAwpDiff, null, "", "", "right", "#49a084", "");
					addCell(playerTable, j, newColNextLvl, null, "", "", "right", "#49a084", "");
				}
			}
		} catch (e) {			
			errorMessage(e);
		}
	}	
}

function createElement(doc, elementType, elementId, elementName, elementClass, elementStyle, elementTooltip, elementOnclick)
{
	try
	{
		var newElement = doc.createElement(elementType);		
		
		newElement.setAttribute("id", elementId);	
		newElement.setAttribute("name", elementName);
		newElement.setAttribute("class", elementClass);
		newElement.setAttribute("style", elementStyle);
		newElement.setAttribute("title", elementTooltip);
		newElement.setAttribute("onclick", elementOnclick);

		return newElement;
	}  catch (e) {
		errorMessage(e);
	}
}

function createCell(doc, cellAttValign, cellAttHeight, cellValue, cellHTML, cellChild, cellClass)
{
	try
	{
		var newCell = doc.createElement("td");
		
		if(cellAttValign) 	newCell.setAttribute("valign", cellAttValign);
		if(cellAttHeight) 	newCell.setAttribute("height", cellAttHeight);
		if(cellValue)		newCell.setAttribute("value", cellValue);
		if(cellHTML)		newCell.innerHTML = cellHTML;
		if(cellChild)		newCell.appendChild(cellChild);
		if(cellClass)		newCell.setAttribute("class", cellClass);
		
		return newCell;
	}  catch (e) {
		errorMessage(e);
	}
}

function createRow(doc, rowAttValign, rowAttHeight)
{
	try
	{
		var newRow = doc.createElement("tr");
		
		newRow.setAttribute("valign", rowAttValign);
		newRow.setAttribute("height", rowAttHeight);
		
		return newRow;
	}  catch (e) {
		errorMessage(e);
	}
}

function createTable(doc, tableClass, tableCellspacing, tableCellpadding)
{
	try
	{
		var newTable = doc.createElement("table");
		
		newTable.setAttribute("class", tableClass);
		newTable.setAttribute("cellspacing", tableCellspacing);
		newTable.setAttribute("cellpadding", tableCellpadding);

		return newTable;
	}  catch (e) {
		errorMessage(e);
	}
}

function createForm(doc)
{
	try
	{
		var newForm = doc.createElement("form");

		return newForm;
	}  catch (e) {
		errorMessage(e);
	}
}

function createButton(doc, btAttValue, btAttClass, btAttName, btAttOnclick)
{
	try
	{
		var newButton = doc.createElement("input");
		
		newButton.setAttribute("type", "submit");
		newButton.setAttribute("value", btAttValue);
		newButton.setAttribute("class", btAttClass);
		newButton.setAttribute("name", btAttName);
		newButton.setAttribute("onclick", btAttOnclick);
		
		return newButton;
	}  catch (e) {
		errorMessage(e);
	}
}

function createCheckbox(doc, chkbxId, chkbxName, chkbxClass, chkbxStyle, chkbxTooltip, chkbxValue,  chkbxChecked, chkbxOnclick)
{
	try
	{
		// var newChkbox = doc.createElement("input");
		var newChkbox = createElement(doc, "input", chkbxId, chkbxName, chkbxClass, chkbxStyle, chkbxTooltip, chkbxOnclick);
		// newChkbox.setAttribute("id", chkbxId);
		newChkbox.setAttribute("type", "checkbox");
		newChkbox.setAttribute("value", chkbxValue);
		// newChkbox.setAttribute("class", chkbxClass);
		// newChkbox.setAttribute("name", chkbxName);
		newChkbox.setAttribute("checked", chkbxChecked);
		// newChkbox.setAttribute("onclick", chkbxOnclick);
		
		return newChkbox;
	}  catch (e) {
		errorMessage(e);
	}
}

function createDropdown(doc, selectId, selectName, selectClass, selectStyle, selectTooltip, selectOnchange)
{
	try
	{
		var newSelect = createElement(doc, "select", selectId, selectName, selectClass, selectStyle, selectTooltip, null);
		
		newSelect.setAttribute("size", "1");
		newSelect.setAttribute("onchange", selectOnchange);
		newSelect.setAttribute("onkeyup", selectOnchange);		
		// newSelect.addEventListener("change", selectOnchange, false);

		return newSelect;
	}  catch (e) {
		errorMessage(e);
	}
}

function getXMLDocument( ajax )
{
	if (typeof DOMParser == "undefined") {
		DOMParser = function(){};

		DOMParser.prototype.parseFromString = function(str, contentType)
		{
			if (typeof ActiveXObject != "undefined") 
			{
				var doc = new ActiveXObject("MSXML.DomDocument");
				doc.loadXML(str);
				// alert("ActiveX");
				return doc;
			} else if ( typeof XMLHttpRequest != "undefined" ) 
			{
				var req = new XMLHttpRequest();
				req.open("GET", "data:" + (contentType || "application/xml") + ";charset=utf-8," + encodeURIComponent(str), false);
				if ( req.overrideMimeType )
					req.overrideMimeType(contentType);
				req.send(null);
				// alert(req.responseXML);
				return req.responseXML;
			} else
				throw new FatalException( "Can't find a valid xml parser", "AJAX::getXMLDocument()" );
		}
	}
	var strDocument = ajax.responseText;
	var xmlDocument = ajax.responseXML;
	try {
		if( ! xmlDocument || xmlDocument.childNodes.length === 0 )
			xmlDocument = (new DOMParser()).parseFromString( strDocument, "application/xml" );
		// alert(xmlDocument);
		return xmlDocument;
	} catch( e ) {
		return null;
	}
} 

function alertArray(array)
{
	var string = "";
	for(var i=0; i<array.length; i++)
	{
		// alert(array[i] + ": " + parseFloat(array[i].replace(".","")));
		string += i + ": " + array[i] + "\n";
	}
	alert(string);
}

// Create an object type UserException
function UserException (message) {
   this.message=message;
   this.name="UserException";
}
// Create an instance of the object type and throw it

function getTableNumber(document, searchstring)
{
	try
	{
		var tableNumber;
		if(document && searchstring)
		{
			var tables = document.getElementsByTagName("table");
			var results = findTableByRegExp(tables, searchstring);
			if(results.length == 1)
			{
				tableNumber = results[0]["table"];
			}
			else
			{
				tableNumber = null;
				myUserException=new UserException("getTableNumber(): Could not clearly determine the table: '" + searchstring + "'.");
				throw myUserException; 
			}			
		}
		else
		{
			tableNumber = null;
			myUserException=new UserException("getTableNumber(): Wrong parameter.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}	
	return tableNumber;
}

function getColumnNumber(document, searchstring)
{
	try
	{
		infoMessage(5, "getColumnNumber(): started");
		var columnNumber;
		if(document && searchstring)
		{
			var tables = document.getElementsByTagName("table");
			var results = findTableByRegExp(tables, searchstring);
			if(results.length == 1)
			{
				columnNumber = results[0]["cell"];
			}
			else
			{
				columnNumber = null;
				// myUserException=new UserException("getColumnNumber(): Could not clearly determine the column: '" + searchstring + "'.");
				errorMessage("getColumnNumber(): Could not clearly determine the column: '" + searchstring + "'.");
				throw myUserException; 
			}			
		}
		else
		{
			columnNumber = null;
			// myUserException=new UserException("getColumnNumber(): Wrong parameter.");
			errorMessage("getColumnNumber(): Wrong parameter.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}	
	return columnNumber;
}

function getRowNumber(document, searchstring)
{
	try
	{
		var columnNumber;
		if(document && searchstring)
		{
			var tables = document.getElementsByTagName("table");
			var results = findTableByRegExp(tables, searchstring);
			if(results.length == 1)
			{
				columnNumber = results[0]["row"];
			}
			else
			{
				columnNumber = null;
				myUserException=new UserException("getColumnNumber(): Could not clearly determine the Row: '" + searchstring + "'.");
				throw myUserException; 
			}			
		}
		else
		{
			columnNumber = null;
			myUserException=new UserException("getRowNumber(): Wrong parameter.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}	
	return columnNumber;
}

function getColumnContent(table, column)
{
	try
	{
		var columnContent;
		if(table && column)
		{
			columnContent = new Array(table.rows.length);
			for(var i=0; i<table.rows.length; i++)
			{
				columnContent[i] = table.rows[i].cells[column];
			}
		}
		else
		{
			columnContent = null;
			myUserException=new UserException("getColumnContent(): Wrong parameter.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}	
	return columnContent;
}

function getFreshnessColumnNumber(document)
{
	try
	{
		var freshnessColumnNumber;		
		if(document)
		{
			freshnessColumnNumber = getColumnNumber(document, /Frische\s*des\s*Spielers/);
		}
		else
		{
			freshnessColumnNumber = null;
			myUserException=new UserException("Could not clearly determine the column of the table containing the freshness of a player.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}
	// alert(freshnessColumnNumber);
	return freshnessColumnNumber;
}

function getFreshnessTableNumber(document)
{
	try
	{
		var freshnessTableNumber;		
		if(document)
		{
			freshnessTableNumber = getTableNumber(document, /Frische\s*des\s*Spielers/);
		}
		else
		{
			freshnessTableNumber = null;
			myUserException=new UserException("Could not clearly determine the column of the table containing the freshness of a player.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}
	// alert(freshnessTableNumber);
	return freshnessTableNumber;
}

function getFreshnessColumnContent(tables)
{
	try
	{
		var results = findTableByRegExp(tables, /Frische\s*des\s*Spielers/);
		var freshnessColumn = new Array();
		var counter=0;
		
		if(results.length == 1)
		{
			freshnessTable 			= tables[results[0]["table"]];
			freshnessColumnNo		= results[0]["cell"];
			freshnessColumnContent	= getColumnContent(freshnessTable, freshnessColumnNo);
			for(var i=0; i<freshnessColumnContent.length; i++)
			{
				freshnessValue = getNumberFromNode(freshnessColumnContent[i]);
				if(!isNaN(freshnessValue))
				{
					freshnessColumn[counter++] = freshnessValue;
				}
			}
			// alertArray(freshnessColumn);
		}
		else
		{
			freshnessColumn = null;
			myUserException=new UserException("Could not clearly determine the column of the table containing the freshness of a player.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}	
	return freshnessColumn;
}

function getTrainingAttendanceColumnNumber(document)
{
	try
	{
		var trainingAttendanceColumnNumber;		
		if(document)
		{
			trainingAttendanceColumnNumber = getColumnNumber(document, /Teilnahme\s*am\s*Training/);
		}
		else
		{
			trainingAttendanceColumnNumber = null;
			myUserException=new UserException("Could not clearly determine the column of the table containing the training attendance of a player.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}
	// alert(trainingAttendanceColumnNumber);
	return trainingAttendanceColumnNumber;
}

function getLocale(locale)
{
	try
	{
		var strLocale;		
		if(locale)
		{
			var localeProperties = document.getElementById("localeProperties");
			if(localeProperties)
			{
				var strLocale = localeProperties.getString(locale);
			}
			else
			{
				strLocale = null;
				myUserException=new UserException("Could not find object holding localisation strings used by Javascript.");
				throw myUserException; 
			}
		}
		else
		{
			strLocale = null;
			myUserException=new UserException("Given localisation string is null.");
			throw myUserException; 
		}
	} catch (e) {
		errorMessage(e);
	}
	return strLocale;
}

function ajaxFunction()
{
	var ajaxRequest;  // The variable that makes Ajax possible!
	
	try{
		// Opera 8.0+, Firefox, Safari
		ajaxRequest = new XMLHttpRequest();
	
		// Create a function that will receive data sent from the server
		ajaxRequest.onreadystatechange = function(){
			if(ajaxRequest.readyState == 4){
				document.myForm.time.value = ajaxRequest.responseText;
			}
		}
		// var age = document.getElementById('age').value;
		// var wpm = document.getElementById('wpm').value;
		// var sex = document.getElementById('sex').value;
		// var queryString = "?age=" + age + "&wpm=" + wpm + "&sex=" + sex;
		ajaxRequest.open("GET", "foxfmdb_access.php", true);
		ajaxRequest.send(null);
	} catch (e) {
		errorMessage(e);
	}
}

function coerce(limitMin, limitMax, value)
{
	var coercedValue;
	
	try
	{
		if(value > limitMax)
		{
			coercedValue = limitMax;
		} else if (value < limitMin)
		{
			coercedValue = limitMin;
		} else 
		{
			coercedValue = value;
		}
		
		infoMessage(5, "coerce(): min: " + limitMin + ", max: " + limitMax + ", value: " + value + "; coerced: " + coercedValue);
		
		return coercedValue;
	} catch (e) {
		errorMessage(e);
	}
}

function getTypeOfGame(string)
{
	try
	{
		infoMessage(5, "getTypeOfGame(" + string + "): started");

		var typeOfGame	= null;
		
		if(string.match(/\wleague\w/i))
		{
			typeOfGame = "League";
		} else if(string.match(/\wfriendly\w/i))
		{
			typeOfGame = "Friendly";
		} else if(string.match(/\wcup\w/i))
		{
			typeOfGame = "Cup";
		}		
		
		return typeOfGame;
	} catch (e) {
		errorMessage(e);
	}
}

function getStadiumBlock(string)
{
	try
	{
		infoMessage(5, "getStadiumBlock(" + string + "): started");

		var blockOfStadium	= null;
		
		if(string.match(/\wblock1\w*/i))
		{
			blockOfStadium = 1;
		} else if(string.match(/\wblock2\w/i))
		{
			blockOfStadium = 2;
		} else if(string.match(/\wblock3\w/i))
		{
			blockOfStadium = 3;
		} else if(string.match(/\wblock4\w/i))
		{
			blockOfStadium = 4;
		} else
		{
			infoMessage(5, "getStadiumBlock(" + string + "): no block could be identfied");
		}
		
		return blockOfStadium;
	} catch (e) {
		errorMessage(e);
	}
}

function getBrowserLanguage()
{
	var language = null;
	try
	{
		infoMessage(5, "getBrowserLanguage(): started");

		language = navigator.language;
	} catch (e) {
		errorMessage(e);
	}
	return language;
}

function insertThousendDevider(number) 
{
	try
	{
		var separator;
		if(getBrowserLanguage().match(/DE/i))
		{
			separator = '.';
		} else if(getBrowserLanguage().match(/EN/i)) {
			separator = ',';
		} else {
			separator = ' ';
		}
		number = '' + number;
		if (number.length > 3) {
			var mod = number.length % 3;
			var output = (mod > 0 ? (number.substring(0,mod)) : '');
			for (i=0 ; i < Math.floor(number.length / 3); i++) {
			if ((mod == 0) && (i == 0))
				output += number.substring(mod+ 3 * i, mod + 3 * i + 3);
				else

				// hier wird das Trennzeichen festgelegt mit '.'
				// output+= '.' + number.substring(mod + 3 * i, mod + 3 * i + 3);
				output+= separator + number.substring(mod + 3 * i, mod + 3 * i + 3);
			}
			return (output);
		}
		else return number;
	} catch (e) {
		errorMessage(e);
	}
}

function addition(a, b)
{
	var sum = new Number();
	try
	{
		number1	= Number(a);
		number2	= Number(b);
		if(!isNaN(number1) && !isNaN(number2))
		{
			sum	= number1 + number2;
			infoMessage(0, "addition(): sum of '" + a + "' and '" + b + "' = " + sum);
		} else  {
			errorMessage("addition(): Could not add '" + a + "' and '" + b + "'!");
		}
	} catch (e) {
		errorMessage(e);
	}
	return sum;
}

function getNoOfColumn(cell)
{
	var noOfColumn = null;
	try
	{
		infoMessage(5, "getNoOfColumn(): started");
	
		if(cell)
		{
			noOfColumn = cell.cellIndex;
		} else {
			errorMessage("Could not find the number of the column.");
		}
		infoMessage(5, "getNoOfColumn: number of the column: " + noOfColumn);
	} catch (e) {
		errorMessage(e);
	}
	return noOfColumn;
}

function foxfm_openDbConn()
{
	try
	{
		// var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("chrome://foxfm/content/resources/sqlite/foxfm.sqlite", Components.interfaces.nsIFile);
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		file.append("foxfm2.sqlite");

		var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);
		var mDBConn = storageService.openDatabase(file); // Will also create the file if it does not exist
		var statement = mDBConn.createStatement("SELECT posName FROM position");
		// var statement = mDBConn.createStatement("INSERT INTO position (\"id\", \"posName\") VALUES(8, \"VS\")");
		
		infoMessage(0, "start SQL execution");
		statement.executeAsync({
			handleResult: function(aResultSet) {
			
					do
					{
					var row = aResultSet.getNextRow();
					infoMessage(0, "handleResult: " + row.getResultByName("posName"));
					} while (row);
			for (var row = aResultSet.getNextRow();	 row;	 row = aResultSet.getNextRow()) 
			{

				var value = row.getResultByName("posName");
				infoMessage(value);
			}
			},

			handleError: function(aError) {
								infoMessage(0, "handleError");

			errorMessage("Error: " + aError.message);
			},

			handleCompletion: function(aReason) {
											infoMessage(0, "handleCompletion");

			if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
			  errorMessage("Query canceled or aborted!");
			}
		});
		infoMessage(0, "finish SQL execution");

		// mDBConn.asyncClose() 
	} catch(e) {
		errorMessage(e);
	}
}

function getColumnNumberByXPATH(document, xpath)
{
	var columnNumber = null;
	try
	{
		infoMessage(4, "getColumnNumberByXPATH(): started");
	
		var xpathresult = document.evaluate(xpath, document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

		if(xpathresult && xpathresult.snapshotLength==1)
		{
			var parentCell	= get1stOccurenceOfParentNode(xpathresult.snapshotItem(0), "td");
			columnNumber	= getNoOfColumn(parentCell);
		} else {
			errorMessage("getColumnNumberByXPATH(): Could not determine the number of the column by the given XAPTH: " + xpath);
		}

		infoMessage(4, "getColumnNumberByXPATH(): number of the column of the given XPATH '" + xpath + "': " + columnNumber);
	} catch (e) {
		errorMessage(e);
	}
	return columnNumber;
}

function getColumnContentByXPATH(document, xpath)
{
	var aColumn = null;

	try
	{
		infoMessage(4, "getColumnContentByXPATH(): started");
		
		var xpathresult = document.evaluate(xpath, document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
		// var xpathresult = document.evaluate('//./table/tbody/tr/td/a/.[@href="?orderby=8"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

		if(xpathresult && xpathresult.snapshotLength==1)
		{
			// get the table containing the column
			var parentTable = get1stOccurenceOfParentNode(xpathresult.snapshotItem(0), "table");		
			if(parentTable)
			{
				var columnNumber	= getColumnNumberByXPATH(document, xpath);
				var aColumn			= getColumnContent(parentTable, columnNumber);
			}
		} else {
			errorMessage("getColumnContentByXPATH(): Could not clearly determine the content of the column by the given XAPTH: " + xpath);
			errorMessage("getColumnContentByXPATH(): Found possibilities: " + xpathresult.snapshotLength);
		}	

		infoMessage(4, "getColumnContentByXPATH(): column content found by XPATH '" + xpath + "': " + aColumn);
	} catch (e) {
		errorMessage(e);
	}
	return aColumn;
}